The problem was first proposed by Hakimi in 1964.[3]
Let be a metric space where is a set and is a metric
A set , is provided together with a parameter . The goal is to find a subset with such that the maximum distance of a point in to the closest point in is minimized. The problem can be formally defined as follows:
For a metric space (,d),
Input: a set , and a parameter .
Output: a set of points.
Goal: Minimize the cost d(v,)
That is, every point in a cluster is in distance at most from its respective center.
[4]
The k-Center Clustering problem can also be defined on a complete undirected graph G = (V, E) as follows:
Given a complete undirected graph G = (V, E) with distances d(vi, vj) ∈ N satisfying the triangle inequality, find a subset C ⊆ V with |C| = k while minimizing:
Computational complexity
In a complete undirected graph G = (V, E), if we sort the edges in non-decreasing order of the distances: d(e1) ≤ d(e2) ≤ ... ≤ d(em) and let Gi = (V, Ei), where Ei = {e1, e2, ..., ei}. The k-center problem is equivalent to finding the smallest index i such that Gi has a dominating set of size at most k.
[5]
Although Dominating Set is NP-complete, the k-center problem remains NP-hard. This is clear, since the optimality of a given feasible solution for the k-center problem can be determined through the Dominating Set reduction only if we know in first place the size of the optimal solution (i.e. the smallest index i such that Gi has a dominating set of size at most k), which is precisely the difficult core of the NP-Hard problems. Although a Turing reduction can get around this issue by trying all values of k.
Approximations
A simple greedy algorithm
A simple greedyapproximation algorithm that achieves an approximation factor of 2 builds using a farthest-first traversal in k iterations.
This algorithm simply chooses the point farthest away from the current set of centers in each iteration as the new center. It can be described as follows:
Pick an arbitrary point into
For every point compute from
Pick the point with highest distance from .
Add it to the set of centers and denote this expanded set of centers as . Continue this till k centers are found
Running time
The ith iteration of choosing the ith center takes time.
The solution obtained using the simple greedy algorithm is a 2-approximation to the optimal solution. This section focuses on proving this approximation factor.
Given a set of n points , belonging to a metric space (,d), the greedy K-center algorithm computes a set K of k centers, such that K is a 2-approximation to the optimal k-center clustering of V.
Another algorithm with the same approximation factor takes advantage of the fact that the k-Center problem is equivalent to finding the smallest index i such that Gi has a dominating set of size at most k and computes a maximal independent set of Gi, looking for the smallest index i that has a maximal independent set with a size of at least k.
[7]
It is not possible to find an approximation algorithm with an approximation factor of 2 − ε for any ε > 0, unless P = NP.
[8]
Furthermore, the distances of all edges in G must satisfy the triangle inequality if the k-center problem is to be approximated within any constant factor, unless P = NP.
[9]
Parameterized approximations
It can be shown that the k-Center problem is W[2]-hard to approximate within a factor of 2 − ε for any ε > 0, when using k as the parameter.[10] This is also true when parameterizing by the doubling dimension (in fact the dimension of a Manhattan metric), unless P=NP.[11] When considering the combined parameter given by k and the doubling dimension, k-Center is still W[1]-hard but it is possible to obtain a parameterized approximation scheme.[12] This is even possible for the variant with vertex capacities, which bound how many vertices can be assigned to an opened center of the solution.[13]
Approximation algorithms
If , the vertex k-center problem can not be (optimally) solved in polynomial time. However, there are some polynomial time approximation algorithms that get near-optimal solutions. Specifically, 2-approximated solutions. Actually, if the best possible solution that can be achieved by a polynomial time algorithm is a 2-approximated one.[14][15][16][17] In the context of a minimization problem, such as the vertex k-center problem, a 2-approximated solution is any solution such that , where is the size of an optimal solution. An algorithm that guarantees to generate 2-approximated solutions is known as a 2-approximation algorithm. The main 2-approximated algorithms for the vertex k-center problem reported in the literature are the Sh algorithm,[18] the HS algorithm,[17] and the Gon algorithm.[15][16] Even though these algorithms are the (polynomial) best possible ones, their performance on most benchmark datasets is very deficient. Because of this, many heuristics and metaheuristics have been developed through the time. Contrary to common sense, one of the most practical (polynomial) heuristics for the vertex k-center problem is based on the CDS algorithm, which is a 3-approximation algorithm[19]
The Sh algorithm
Formally characterized by David Shmoys in 1995,[18] the Sh algorithm takes as input a complete undirected graph , a positive integer , and an assumption on what the optimal solution size is. The Sh algorithm works as follows: selects the first center at random. So far, the solution consists of only one vertex, . Next, selects center at random from the set containing all the vertices whose distance from is greater than . At this point, . Finally, selects the remaining centers the same way was selected. The complexity of the Sh algorithm is , where is the number of vertices.
The HS algorithm
Proposed by Dorit Hochbaum and David Shmoys in 1985, the HS algorithm takes the Sh algorithm as basis.[17] By noticing that the value of must equals the cost of some edge in , and since there are edges in , the HS algorithm basically repeats the Sh algorithm with every edge cost. The complexity of the HS algorithm is . However, by running a binary search over the ordered set of edge costs, its complexity is reduced to .
The Gon algorithm
Proposed independently by Teofilo Gonzalez,[15] and by Martin Dyer and Alan Frieze[16] in 1985, the Gon algorithm is basically a more powerful version of the Sh algorithm. While the Sh algorithm requires a guess on , the Gon algorithm prescinds from such guess by noticing that if any set of vertices at distance greater than exists, then the farthest vertex must be inside such set. Therefore, instead of computing at each iteration the set of vertices at distance greater than and then selecting a random vertex, the Gon algorithm simply selects the farthest vertex from every partial solution . The complexity of the Gon algorithm is , where is the number of vertices.
The CDS algorithm
Proposed by García Díaz et al. in 2017,[19] the CDS algorithm is a 3-approximation algorithm that takes ideas from the Gon algorithm (farthest point heuristic), the HS algorithm (parametric pruning), and the relationship between the vertex k-center problem and the Dominating Set problem. The CDS algorithm has a complexity of . However, by performing a binary search over the ordered set of edge costs, a more efficiente heuristic named CDSh is proposed. The CDSh algorithm complexity is . Despite the suboptimal performance of the CDS algorithm, and the heuristic performance of CDSh, both present a much better performance than the Sh, HS, and Gon algorithms.
Parameterized approximations
It can be shown that the k-Center problem is W[2]-hard to approximate within a factor of 2 − ε for any ε > 0, when using k as the parameter.[20] This is also true when parameterizing by the doubling dimension (in fact the dimension of a Manhattan metric), unless P=NP.[21] When considering the combined parameter given by k and the doubling dimension, k-Center is still W[1]-hard but it is possible to obtain a parameterized approximation scheme.[22] This is even possible for the variant with vertex capacities, which bound how many vertices can be assigned to an opened center of the solution.[23]
Experimental comparison
Some of the most widely used benchmark datasets for the vertex k-center problem are the pmed instances from OR-Lib.,[24] and some instances from TSP-Lib.[25] Table 1 shows the mean and standard deviation of the experimental approximation factors of the solutions generated by each algorithm over the 40 pmed instances from OR-Lib[19]
Table 1. Experimental approximation factor over pmed instances from OR-Lib
Algorithm
Complexity
HS
1.532
0.175
Gon
1.503
0.122
CDSh
1.035
0.031
CDS
1.020
0.027
Table 2. Experimental approximation factor over instances from TSP-Lib
Algorithm
Algorithm
Gon
1.396
0.091
HS
1.318
0.108
CDSh
1.124
0.065
CDS
1.042
0.038
Polynomial heuristics
Greedy pure algorithm
The greedy pure algorithm (or Gr) follows the core idea of greedy algorithms: to take optimal local decisions. In the case of the vertex k-center problem, the optimal local decision consists in selecting each center in such a way that the size of the solution (covering radius) is minimum at each iteration. In other words, the first center selected is the one that solves the 1-center problem. The second center selected is the one that, along with the previous center, generates a solution with minimum covering radius. The remaining centers are selected the same way. The complexity of the Gr algorithm is .[26] The empirical performance of the Gr algorithm is poor on most benchmark instances.
Scoring algorithm
The Scoring algorithm (or Scr) was introduced by Jurij Mihelič and Borut Robič in 2005.[27] This algorithm takes advantage of the reduction from the vertex k-center problem to the minimum dominating set problem. The problem is solved by pruning the input graph with every possible value of the optimal solution size and then solving the minimum dominating set problem heuristically. This heuristic follows the lazy principle, which takes every decision as slow as possible (opossed to the greedy strategy). The complexity of the Scr algorithm is . The empirical performance of the Scr algorithm is very good on most benchmark instances. However, its running time rapidly becomes impractical as the input grows. So, it seems to be a good algorithm only for small instances.
^Pacheco, Joaquín A.; Casado, Silvia (December 2005). "Solving two location models with few facilities by using a hybrid heuristic: a real health resources case". Computers & Operations Research. 32 (12): 3075–3091. doi:10.1016/j.cor.2004.04.009. ISSN0305-0548.
^Hakimi, S. L. (1964). "Optimum Locations of Switching Centers and the Absolute Centers and Medians of a Graph". Operations Research. 12 (3): 450–459. doi:10.1287/opre.12.3.450. JSTOR168125.
^ abShmoys, David B. (1995). "Computing near-optimal solutions to combinatorial optimization problems". Combinatorial Optimization. DIMACS Series in Discrete Mathematics and Theoretical Computer Science. Vol. 20. pp. 355––397. CiteSeerX10.1.1.33.1719. doi:10.1090/dimacs/020/07. ISBN9780821802397.
^ abcGarcia-Diaz, Jesus; Sanchez-Hernandez, Jairo; Menchaca-Mendez, Ricardo; Menchaca-Mendez, Rolando (2017-07-01). "When a worse approximation factor gives better performance: a 3-approximation algorithm for the vertex k-center problem". Journal of Heuristics. 23 (5): 349–366. doi:10.1007/s10732-017-9345-x. ISSN1381-1231. S2CID254500532.
^Beasley, J. E. (1990). "OR-Library: Distributing Test Problems by Electronic Mail". The Journal of the Operational Research Society. 41 (11): 1069–1072. doi:10.2307/2582903. JSTOR2582903.
^Reinelt, Gerhard (November 1991). "TSPLIB—A Traveling Salesman Problem Library". ORSA Journal on Computing. 3 (4): 376–384. doi:10.1287/ijoc.3.4.376. ISSN0899-1499.